#INCLUDE "ti82.h"
#INCLUDE "keys.inc"

.ORG START_ADDR
.DB "Prime v1.2",0

	ld d,$00		;d = 0
	ld e,d			;e = d = 0

Display:
	push de			;Store the value of de
	ROM_CALL(CLEARLCD)	;Clear the screen
	ld hl,$0000		;Set the cursor to top left
	ld (CURSOR_POS),hl
	pop hl			;Move stored value of de into hl
	push hl			;Store the value of hl
	ROM_CALL(D_HL_DECI)	;Display the value of hl
	pop de			;Move stored value of hl into de

GettingNumber:
	call GET_KEY		;Check for key
	cp G_ENTER		;If enter is hit goto check
	jr z,Check
	cp G_MODE		;If mode is hit return to ASH
	ret z
	cp G_LEFT		;If left is hit goto DownMore
	jr z,DownMore
	cp G_DOWN		;If down is hit goto Down
	jr z,Down
	cp G_RIGTH		;If right is hit goto UpMore
	jr z,UpMore
        cp G_UP			;If something other than Up is hit goto GettingNumber
	jr nz,GettingNumber
	inc de			;de = de + 1
	jr Display		;Display de

Down:
	dec de			;de = de - 1
	jr Display		;Display de

UpMore:
	ld b,100		;We want to loop 100 times

UpLoop:
	inc de			;de = de + 1
	djnz UpLoop		;Has it looped 100 times yet?
	jr Display		;Display de

DownMore:
	ld b,100		;We want to loop 100 times

DownLoop:
	dec de			;de = de - 1
	djnz DownLoop		;Has it looped 100 times yet?
	jr Display		;Display de

Check:				;Here we check to see if de is prime
	ld hl,$0002		;Put the cursor lower
	ld (CURSOR_POS),hl
	push hl			;Set bc = hl = $0002
	pop bc
	ld a,e			;a = e
	srl a			;Is a even?
	jr nc,Divided		;If so then de has been divided
	ld a,$03		;If not a = 3
	
Loop:
	ld h,$00		;hl = a
	ld l,a
	push hl			;bc = hl = a
	pop bc

Adding:
	add hl,bc		;hl = hl + bc
	jr c,NoDiv		;If we went over 65535 (2^16 - 1) then it didn't divide 
	call CP_HL_DE		;Compare hl and de
	jr z,Divided		;If hl = de then de has been divided by bc
	jr c,Adding		;If hl is less then de then keep adding bc

NoDiv:				;de was not divided by bc
	inc a			;a = a + 2
	inc a
	cp $FF			;If a <> 255 (max 8bit register value)...
	jr nz,Loop		;Try this new value of a

Prime:				;de is prime
	ld hl,PrimeText		;Load location of text into hl
	ROM_CALL(D_ZT_STR)	;Display text
	jr GettingNumber	;Get new number

Divided:			;de has been divided
	push de			;Save de for later
	ld hl,CompText		;Load location of text into hl
	ROM_CALL(D_ZT_STR)	;Display text
	ld hl,$0003		;Move the cursor down
	ld (CURSOR_POS),hl
	push bc			;hl = bc
	pop hl
	ROM_CALL(D_HL_DECI)	;Display hl
	pop de			;Restore de
	jr GettingNumber	;Get new number

CompText:
.db "Divisible by:",0

PrimeText:
.db "Prime",0

.end
